###############################################################################
# DelMembers.pm                                                               #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 2.7.00                                                 #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2017 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by:  The YaBB Development Team                                     #
#               with assistance from the YaBB community.                      #
###############################################################################
#  DelMembers mod created by Dandello,                                        #
#  based on the ExMember mod by Carsten Dalgaard (2011)                       #
###############################################################################
use strict;
no strict qw(refs);
use warnings;
use CGI::Carp qw(fatalsToBrowser);
our $VERSION         = '2.7.00';
our $delmemberspmver = 'YaBB 2.7.00 $Revision: 0.2 $';

our ($action);
$action ||= q{};
if ( $action eq 'detailedversion' ) { return 1; }

load_language('Mods/DelMembers');
load_language('Admin');
is_admin_or_gmod();
get_forum_master();

our (
    $adminurl, $boardsdir,    $currentboard, $datadir,
    $date,     $exmembername, $memberdir,    $uid,
    $username, $yymain,       %admin_img,    %admintxt,
    %croak,    %delml_txt,    %INFO,         %thread_arrayref,
);
our $exmemdir = qq~$memberdir/exmembers~;

load_language('Admin');

sub DelMl {
    our (%exmemberinf);
    if ( -e "$exmemdir/Exmembers.pm" ) {
        require "$exmemdir/Exmembers.pm";
    }
    else { %exmemberinf = (); }
    $yymain .= qq~
    <div class="bordercolor rightboxdiv">
        <table class="border-space pad-cell" style="margin-bottom: .5em;">
            <tr>
                <td class="titlebg">$admin_img{'prefimg'} <b>$delml_txt{'100'}</b></td>
            </tr><tr>
                <td class="catbg"><span class="small">$delml_txt{'101'} <i>$delml_txt{'102'}</i></span></td>
            </tr>
        </table>
    </div>
    <div class="bordercolor rightboxdiv">
        <table class="border-space pad-cell" style="margin-bottom: .5em;">
            <colgroup>
                <col style="width:200px" span="2" />
                <col style="width:60px" />
                <col style="width:100px" span="2" />
            </colgroup>
            <tr>
                <td class="titlebg" colspan="5">$admin_img{'xx'}&nbsp; <b>$admintxt{'a6_sub20'}</b></td>
            </tr><tr>
                <td class="windowbg2" colspan="5"><div class="pad_more">$delml_txt{'description'}</div></td>
            </tr><tr>
                <td class="catbg center"><b>$delml_txt{'name'}</b></td>
                <td class="catbg center"><b>$delml_txt{'deletedon'}</b></td>
                <td class="catbg center"><b>$delml_txt{'postcount'}</b></td>
                <td class="catbg center" colspan="2"><b>$delml_txt{'action'}</b></td>
            </tr>~;
    my $i = 0;
    for my $exmembername (
        sort { lc $exmemberinf{$a} cmp lc $exmemberinf{$b} }
        keys %exmemberinf
      )
    {
        my ( $exmemrealname, $deldate, $excount, $replaced ) =
          @{ $exmemberinf{$exmembername} };
        my $deletedate = timeformat( $deldate, 1 );
        my $replacetext =
          $replaced
          ? qq~<span class="important">$delml_txt{'replaced'}</span>~
          : qq~<a href="$adminurl?action=delreplace;exmemb=$exmembername;deldat=$deldate;totcnt=$excount">$delml_txt{'replace'}</a>~;
        my $returnmem = q{};
        if (   !$replaced
            && -e "$exmemdir/$exmembername.xvars"
            && !-e "$memberdir/$exmembername.vars" )
        {
            $returnmem =
qq~ <a href="$adminurl?action=delreplacemem;exmemb=$exmembername">$delml_txt{'reinstate'}</a>~;
        }
        $yymain .= qq~<tr>
            <td class="windowbg">$exmemrealname$returnmem</td>
            <td class="windowbg">$deletedate</td>
            <td class="windowbg center">$excount</td>
            <td class="windowbg center">$replacetext</td>
            <td class="windowbg center"><a href="$adminurl?action=delremove;exmemb=$exmembername;deldat=$deldate;totcnt=$excount">$delml_txt{'remove'}</a></td>
        </tr>~;
        $i++;
    }
    undef %exmemberinf;
    if ( $i == 0 ) {
        $yymain .= qq~<tr>
            <td class="windowbg center" colspan="5">$delml_txt{'noexmemb'}</td>
        </tr>~;
    }

    $yymain .= q~
    </table>
    </div>
    ~;
    our $yytitle     = "$admintxt{'a6_sub20'}";
    our $action_area = 'viewdelmembers';
    admintemplate();
    return;
}

sub DelReplace {
    automaintenance('on');
    my $exuser = $INFO{'exmemb'};
    my $exdate = $INFO{'deldat'};
    my $totcnt = $INFO{'totcnt'};
    our ($TOPICINFO);
    fopen( 'TOPICINFO', '<', "$exmemdir/$exuser.xlog" );
    my %extopics = map /(.*)\|(.*)/, <$TOPICINFO>;
    fclose('TOPICINFO');

    for my $extopic ( keys %extopics ) {
        my ( $pstcnt, undef ) = split /\,/xsm, $extopics{$extopic};
        our ($FILE);
        fopen( 'FILE', '<', "$datadir/$extopic.txt" );
        my @topicdata = <$FILE>;
        fclose('FILE');
        my $x = 0;
        for my $i ( 0 .. $#topicdata ) {
            my (
                $top1,  $top2,   $top3, $exmdate,   $exmusername,
                $top6,  $top7,   $top8, $exmessage, $top10,
                $exmlm, $exmlmb, $top13
            ) = split /[|]/xsm, $topicdata[$i];
            if ( $exmusername eq $exuser && $exmdate < $exdate ) {
                chomp $top13;
                $exmessage =
                  qq~$delml_txt{'replacetxt'} ${$uid.$username}{'realname'}~;
                $exmlm  = $date;
                $exmlmb = $username;
                $topicdata[$i] =
qq~$top1|$top2|$top3|$exmdate|$exmusername|$top6|$top7|$top8|$exmessage|$top10|$exmlm|$exmlmb|$top13\n~;
                $x++;
            }
            if ( $x > $pstcnt ) { last; }
        }
        fopen( 'FILE', '>', "$datadir/$extopic.txt" );
        print {$FILE} @topicdata;
        fclose('FILE');
    }
    undef %extopics;
    our (%exmemberinf);
    if ( -e "$exmemdir/Exmembers.pm" ) {
        require "$exmemdir/Exmembers.pm";
    }
    my $exmemb = q{};
    foreach ( keys %exmemberinf ) {
        my ( $exmemrealname, $deldate, $excount, $replaced ) = @{ $exmemberinf{$_} };
        $exmemb .=
"\$exmemberinf{'$_'} = ['$exmemrealname', '$deldate', '$excount', '$replaced'];\n";
        if ( $_ eq $exuser ) {
            $exmemb .=
"\$exmemberinf{'$_'} = ['$exmemrealname', '$deldate', '$excount', '1'];\n";
        }
    }
    $exmemb .= qq~\n1;\n~;
    our ($EXMEMBINFO);
    fopen( 'EXMEMBINFO', '>', "$exmemdir/Exmembers.pm" );
    print {$EXMEMBINFO} $exmemb;
    fclose('EXMEMBINFO');
    undef %exmemberinf;
    unlink "$exmemdir/$exuser.xvars";
    unlink "$exmemdir/$exuser.xims";
    unlink "$exmemdir/$exuser.xmsg";
    unlink "$exmemdir/$exuser.xout";
    unlink "$exmemdir/$exuser.ximst";
    unlink "$exmemdir/$exuser.ximd";
    unlink "$exmemdir/$exuser.xlst";

    automaintenance('off');
    $yymain .= qq~
    <div class="bordercolor rightboxdiv">
        <table class="border-space pad-cell" style="margin-bottom: .5em;">
            <tr>
                <td class="titlebg" colspan="5">$admin_img{'xx'}&nbsp; <b>$admintxt{'a6_sub20'}</b></td>
            </tr><tr>
                <td class="windowbg2">$delml_txt{'done'} $totcnt $delml_txt{'postcount'} $delml_txt{'replaced'}</td>
            </tr>
        </table>
    </div>
    ~;
    our $yytitle     = "$admintxt{'a6_sub20'}";
    our $action_area = 'viewdelmembers';
    admintemplate();
}

sub DelRemove {
    automaintenance('on');
    my $exuser = $INFO{'exmemb'};
    my $exdate = $INFO{'deldat'};
    my $totcnt = $INFO{'totcnt'};
    our ($TOPICINFO);
    fopen( 'TOPICINFO', '<', "$exmemdir/$exuser.xlog" );
    my %extopics = map /(.*)\|(.*)/, <$TOPICINFO>;
    fclose('TOPICINFO');
    our ($FILE);

    for my $extopic ( keys %extopics ) {
        fopen( 'FILE', '<', "$datadir/$extopic.txt" )
          or fatal_error( 'cannot_open', "$datadir/$extopic.txt", 1 );
        my @topicdata = <$FILE>;
        fclose('FILE');
        message_totals( 'load', $extopic );
        my $currentboard = ${$extopic}{'board'};
        my $exdelarr     = q{};
        for my $i ( 0 .. $#topicdata ) {
            my ( undef, undef, undef, $exmdate, $exmusername, undef ) =
              split /[|]/xsm, $topicdata[$i], 6;
            if ( $exmusername eq $exuser && $exmdate < $exdate ) {
                $exdelarr .= q~1|~;
            }
            else {
                $exdelarr .= q~0|~;
            }
        }
        $exdelarr =~ s/\|\Z//sm;
        DelExposts( $extopic, $exdelarr );
    }
    undef %extopics;
    our ($EXMEMBINFO);
    our %exmemberinf;
    if ( -e "$exmemdir/Exmembers.pm" ) {
        require "$exmemdir/Exmembers.pm";
       delete $exmemberinf{$exuser};
    }
    my $exmemb = q{};

    foreach ( keys %exmemberinf ) {
        my ( $exmemrealname, $deldate, $excount, $replaced ) =
          @{ $exmemberinf{$exmembername} };
        $exmemb .=
"\$exmemberinf{'$_'} = ['$exmemrealname', '$deldate', '$excount', '$replaced'];\n";
    }
    $exmemb .= qq~1;\n~;
    fopen( 'EXMEMBINFO', '>', "$exmemdir/Exmembers.pm" );
    print {$EXMEMBINFO} $exmemb;
    fclose('EXMEMBINFO');
    undef %exmemberinf;
    unlink("$exmemdir/$exuser.xlog");
    unlink "$exmemdir/$exuser.xvars";
    unlink "$exmemdir/$exuser.xims";
    unlink "$exmemdir/$exuser.xmsg";
    unlink "$exmemdir/$exuser.xout";
    unlink "$exmemdir/$exuser.ximst";
    unlink "$exmemdir/$exuser.ximd";
    automaintenance('off');
    $yymain .= qq~
    <div class="bordercolor rightboxdiv">
        <table class="border-space pad-cell" style="margin-bottom: .5em;">
            <tr>
                <td class="titlebg" colspan="5">$admin_img{'xx'}&nbsp; <b>$admintxt{'a6_sub20'}</b></td>
            </tr><tr>
                <td class="windowbg2">$delml_txt{'done'} $totcnt $delml_txt{'postcount'} $delml_txt{'removed'}</td>
            </tr>
        </table>
    </div>
    ~;
    our $yytitle     = "$admintxt{'a6_sub20'}";
    our $action_area = 'viewdelmembers';
    admintemplate();
    return;
}

sub DelExposts {
    my $thread = $_[0];
    my @delarray = split /[|]/xsm, $_[1];
    if ( !ref( $thread_arrayref{$thread} ) ) {
        our ($FILE);
        fopen( 'FILE', '<', "$datadir/$thread.txt" )
          or fatal_error( 'cannot_open', "$datadir/$thread.txt", 1 );
        @{ $thread_arrayref{$thread} } = <$FILE>;
        fclose('FILE');
    }
    my @messages = @{ $thread_arrayref{$thread} };
    my $kill     = 0;
    my (@message);
    for my $count ( reverse 0 .. $#messages ) {
        if ( $delarray[$count] > 0 ) {
            chomp $messages[$count];
            @message = split /[|]/xsm, $messages[$count];
            my $musername = $message[4];
            if ( $message[12] ) {
                require Admin::Attachments;
                my %remattach;
                $message[12] =~ s/,/|/gsm;
                $remattach{$thread} = $message[12];
                remove_attachments( \%remattach );
            }
            splice @messages, $count, 1;
            $kill++;
        }
    }
    if ( !@messages ) {
        require Sources::Favorites;
        $INFO{'ref'} = 'delete';
        rem_fav($thread);
        require Sources::RemoveTopic;
        my $iamposter = ( $message[4] eq $username ) ? 1 : 0;
        $INFO{'moveit'} = 1;
        $INFO{'thread'} = $thread;
        remove_thread();
        return;
    }
    @{ $thread_arrayref{$thread} } = @messages;
    our ($FILE);
    fopen( 'FILE', '>', "$datadir/$thread.txt" )
      or fatal_error( 'cannot_open', "$datadir/$thread.txt", 1 );
    print {$FILE} @{ $thread_arrayref{$thread} };
    fclose('FILE');
    my @firstmessage = split /[|]/xsm, ${ $thread_arrayref{$thread} }[0];
    my @lastmessage = split /[|]/xsm,
      ${ $thread_arrayref{$thread} }[ $#{ $thread_arrayref{$thread} } ];
    ${$thread}{'replies'} = $#{ $thread_arrayref{$thread} };
    ${$thread}{'lastposter'} =
      $lastmessage[4] eq 'Guest' ? qq~Guest-$lastmessage[1]~ : $lastmessage[4];
    message_totals( 'update', $thread );
    boardtotals( 'load', $currentboard );
    ${ $uid . $currentboard }{'messagecount'} -= $kill;
    my $threadline = q{};
    our ($BOARDFILE);
    fopen( 'BOARDFILE', '+<', "$boardsdir/$currentboard.txt" )
      or fatal_error( 'cannot_open', "$boardsdir/$currentboard.txt", 1 );
    my @buffer = <$BOARDFILE>;

    for my $aa ( 0 .. $#buffer ) {
        if ( $buffer[$aa] =~ /^$thread\|/xsm ) {
            $threadline = $buffer[$aa];
            splice @buffer, $aa, 1;
            last;
        }
    }
    chomp $threadline;
    my @newthreadline = split /[|]/xsm, $threadline;
    $newthreadline[1] = $firstmessage[0];
    $newthreadline[7] = $firstmessage[5];
    $newthreadline[4] = $lastmessage[3];
    $newthreadline[5] = ${$thread}{'replies'};
    my $inserted = 0;

    for my $aa ( 0 .. $#buffer ) {
        if ( ( split /[|]/xsm, $buffer[$aa], 6 )[4] < $newthreadline[4] ) {
            splice( @buffer, $aa, 0, join( '|', @newthreadline ) . "\n" );
            $inserted = 1;
            last;
        }
    }
    if ( !$inserted ) { push( @buffer, join( '|', @newthreadline ) . "\n" ); }
    truncate $BOARDFILE, 0;
    seek $BOARDFILE, 0, 0;
    print {$BOARDFILE} @buffer;
    fclose('BOARDFILE');
    board_setlast_info( $currentboard, \@buffer );
    return;
}

sub delreplacemem {
    my $currentmem = $INFO{'exmemb'};
    automaintenance('on');
    my $exmemdir = qq~$memberdir/exmembers~;
    rename( "$exmemdir/$currentmem.xvars", "$memberdir/$currentmem.vars" );
    rename( "$exmemdir/$currentmem.xmsg",  "$memberdir/$currentmem.msg" );
    rename( "$exmemdir/$currentmem.xlog",  "$memberdir/$currentmem.rlog" );
    rename( "$exmemdir/$currentmem.xlst",  "$memberdir/$currentmem.lst" );
    if ( -e "$exmemdir/$currentmem.xout" ) {
        rename( "$exmemdir/$currentmem.xout", "$memberdir/$currentmem.outbox" );
    }
    if ( -e "$exmemdir/$currentmem.xims" ) {
        rename( "$exmemdir/$currentmem.xims", "$memberdir/$currentmem.ims" );
    }
    if ( -e "$exmemdir/$currentmem.ximst" ) {
        rename( "$exmemdir/$currentmem.ximst",
            "$memberdir/$currentmem.imstore" );
    }
    if ( -e "$exmemdir/$currentmem.ximd" ) {
        rename( "$exmemdir/$currentmem.ximd",
            "$memberdir/$currentmem.imdraft" );
    }
    my $exmemb = ();
    our %exmemberinf;
    if ( -e "$exmemdir/Exmembers.pm" ) {
        require "$exmemdir/Exmembers.pm";
    }
    for my $exmembername (
        sort { lc $exmemberinf{$a} cmp lc $exmemberinf{$b} }
        keys %exmemberinf
      )
    {
        my ( $exmemrealname, $deldate, $excount, $replaced ) =
          @{ $exmemberinf{$exmembername} };
        if ( $currentmem ne $exmembername ) {
            $exmemb .=
qq~\$exmemberinf{'$exmembername'} = ['$exmemrealname', '$deldate', '$excount', '$replaced'];\n~;
        }
        else { $exmemb .= q{}; }
    }
    $exmemb .= qq~\n1;\n~;
    our ($EXMEMB);
    fopen( 'EXMEMB', '>', "$exmemdir/Exmembers.pm" );
    print {$EXMEMB} $exmemb;
    fclose('EXMEMB');
    automaintenance('off');

    $yymain .= qq~
    <div class="bordercolor rightboxdiv">
        <table class="border-space pad-cell" style="margin-bottom: .5em;">
            <tr>
                <td class="titlebg" colspan="5">$admin_img{'xx'}&nbsp; <b>$admintxt{'a6_sub20'}</b></td>
            </tr><tr>
                <td class="windowbg2">$delml_txt{'done'} $currentmem $delml_txt{'reinstated'}</td>
            </tr>
        </table>
    </div>
    ~;
    our $yytitle     = "$admintxt{'a6_sub20'}";
    our $action_area = 'viewdelmembers';
    admintemplate();
    return;
}

1;
